// ATMega8a-su
#include "OneButton.h"
#include <Thread.h>
#include <EEPROMex.h>
#include "SevSeg.h"
SevSeg sevseg;

#define LED 6 //к транзистору VT1
#define Button 5 //к кнопке SB1
#define HA_PIN 3 //к пьезоэлектрическому излучателю звука HA1
#define HA_HZ 1000 //частота в HZ звукового сигнала
#define HA_TIME 200 //продолжительность звукового сигнала

#define time_lp 3 //время до срабатывания режима установки
#define time_l 5 //время в течении которого возможна установка
#define time_u 6 //время до начала ускоренного набора значения таймера


byte numDigits = 3;
byte digitPins[] = {A2, A0, A1}; //PC2 PC0 PC1
byte segmentPins[] = {7, 13, 9, 8, 11, 12, 10}; // A, B, C, D, E, F, G
bool resistorsOnSegments = false;
byte hardwareConfig = COMMON_CATHODE;
bool updateWithDelays = false;
bool disableDecPoint = true;
bool leadingZeros = false;

unsigned int tim = 0;
int lp = 0;
int s = 0;
unsigned int TimerN = 0;

OneButton button(Button, true);
Thread myThread = Thread();
void setup() {
  pinMode(LED, OUTPUT);
  digitalWrite(LED, LOW);  
  myThread.onRun(Timer10);
  myThread.setInterval(10);
  button.attachClick(Click);
  button.attachDoubleClick(DoubleClick);
  button.attachLongPressStop(LongPressStop);
  button.attachLongPressStart(LongPressStart);
  button.setDebounceTicks(10);
  sevseg.begin(hardwareConfig, numDigits, digitPins, segmentPins, resistorsOnSegments, updateWithDelays, leadingZeros, disableDecPoint);
  sevseg.setBrightness(100);
  tim = EEPROM.readInt(0); // чтение значения времени таймера, начиная с адреса 0
  Tim(3, 1);
  tone(HA_PIN, HA_HZ, HA_TIME);
  Serial.println("OK");
}

void loop() { 
  if (myThread.shouldRun()) {
    myThread.run();
  }
  button.tick();
  sevseg.refreshDisplay();
}

void Timer10() {
  static int f = 0;
  static unsigned int Timer500 = 0;
  static unsigned int Timer1000 = 0;
  Timer500++;
  Timer1000++;
  if (f == 2 && lp == 1) {
    Tim(1, 1);
  }
  if (Timer500 == 50) {
    if (f == 1) {
      static int l = HIGH;
      l = !l;
      Tim(3, l);
    }
    Timer500 = 0;
  }
  if (Timer1000 == 100) {
    if (lp == 1) {
      TimerN++;
      if (TimerN > time_lp) {
        if (f == 0) {
          tim = 0;
        }
        f = 1;
        s = 0;
      }
      if (TimerN > time_u) {
        f = 2;
        TimerN = time_u + 1;
      }
    }
    if (lp == 0) {
      f = 1;
      if (TimerN < 2 && TimerN > 0) {
        EEPROM.writeInt(0, tim); // запись нового значения времени таймера, начиная с адреса 0
      }
      if (TimerN < 1) {
        f = 0;
        TimerN = 0;
      } else {
        TimerN--;
      }
    }
    if (TimerN == 0 && s == 1) {
      digitalWrite(LED, HIGH);
      Tim(2, 1);
      if (tim < 6 && tim > 0) {
        tone(HA_PIN, HA_HZ, HA_TIME);
      }
      if (tim < 1) {
        digitalWrite(LED, LOW);
      }
      if (tim == 0) {
        s = 0;
      }
    }
    Timer1000 = 0;
  }
}

void Tim(int a, int b) {
  if (a == 1) {
    tim++;
    if (tim > 999) {
      tim = 0;
    }
    Disp(b);
  }
  if (a == 2) {
    if (tim < 1) {
      tim = 0;
    } else {
      tim--;
    }
    Disp(b);
  }
  if (a == 3) {
    Disp(b);
  }
}

void Disp(int a) {
  if (a == 1) {
    sevseg.setNumber(tim);
  } else if (a == 0) {
    sevseg.blank();
  }
}

void Click() {
  if (TimerN > 1) {
    TimerN = time_l;
    Tim(1, 1);
  } else {
    s = 1;
  }
} 

void DoubleClick() {
  digitalWrite(LED, LOW);
  s = 0;
  tim = EEPROM.readInt(0);
  Tim(3, 1);
} 

void LongPressStart() {
  lp = 1;
}

void LongPressStop() {
  lp = 0;
  TimerN = time_l;
}
